---
title: clipPathUnits
slug: Web/SVG/Attribute/clipPathUnits
tags:
  - SVG
  - SVG Attribute
---
<div>{{SVGRef}}</div>

<p>The <strong><code>clipPathUnits</code></strong> attribute indicates which coordinate system to use for the contents of the {{ SVGElement("clipPath") }} element.</p>

<p>Only one element is using this attribute: {{SVGElement('clipPath')}}</p>

<div id="topExample">
<div class="hidden">
<pre class="brush: css">html,body,svg { height:100% }</pre>
</div>

<pre class="brush: html">&lt;svg viewBox="0 0 100 100"&gt;
  &lt;clipPath id="myClip1" clipPathUnits="userSpaceOnUse"&gt;
    &lt;circle cx="50" cy="50" r="35" /&gt;
  &lt;/clipPath&gt;

  &lt;clipPath id="myClip2" clipPathUnits="objectBoundingBox"&gt;
    &lt;circle cx=".5" cy=".5" r=".35" /&gt;
  &lt;/clipPath&gt;

  &lt;!-- Some reference rect to materialized to clip path --&gt;
  &lt;rect id="r1" x="0"  y="0"  width="45" height="45" /&gt;
  &lt;rect id="r2" x="0"  y="55" width="45" height="45" /&gt;
  &lt;rect id="r3" x="55" y="55" width="45" height="45" /&gt;
  &lt;rect id="r4" x="55" y="0"  width="45" height="45" /&gt;

  &lt;!-- The first 3 rect are clipped with useSpaceOnUse units --&gt;
  &lt;use clip-path="url(#myClip1)" xlink:href="#r1" fill="red" /&gt;
  &lt;use clip-path="url(#myClip1)" xlink:href="#r2" fill="red" /&gt;
  &lt;use clip-path="url(#myClip1)" xlink:href="#r3" fill="red" /&gt;

  &lt;!-- The last rect is clipped with objectBoundingBox units --&gt;
  &lt;use clip-path="url(#myClip2)" xlink:href="#r4" fill="red" /&gt;
&lt;/svg&gt;</pre>

<p>{{EmbedLiveSample('topExample', '100%', 200)}}</p>
</div>

<h2 id="clipPath">clipPath</h2>

<p>For {{SVGElement('clipPath')}}, <code>clipPathUnits</code> define the coordinate system in use for the content of the element.</p>

<table class="properties">
 <tbody>
  <tr>
   <th scope="row">Value</th>
   <td><code>userSpaceOnUse</code> | <code>objectBoundingBox</code></td>
  </tr>
  <tr>
   <th scope="row">Default value</th>
   <td><code>userSpaceOnUse</code></td>
  </tr>
  <tr>
   <th scope="row">Animatable</th>
   <td>Yes</td>
  </tr>
 </tbody>
</table>

<dl>
 <dt>userSpaceOnUse</dt>
 <dd>This value indicates that all coordinates inside the {{SVGElement('clipPath')}} element refer to the user coordinate system as defined when the clipping path was created.</dd>
 <dt>objectBoundingBox</dt>
 <dd>This value indicates that all coordinates inside the {{SVGElement('clipPath')}} element are relative to the bounding box of the element the clipping path is applied to. It means that the origin of the coordinate system is the top left corner of the object bounding box and the width and height of the object bounding box are considered to have a length of 1 unit value.</dd>
</dl>

<h2 id="Specifications">Specifications</h2>

<table class="standard-table">
 <thead>
  <tr>
   <th scope="col">Specification</th>
   <th scope="col">Status</th>
   <th scope="col">Comment</th>
  </tr>
 </thead>
 <tbody>
  <tr>
   <td>{{SpecName("CSS Masks", "#element-attrdef-clippath-clippathunits", "clipPathUnits")}}</td>
   <td>{{Spec2("CSS Masks")}}</td>
   <td> </td>
  </tr>
  <tr>
   <td>{{SpecName("SVG1.1", "masking.html#ClipPathElementClipPathUnitsAttribute", "clipPathUnits")}}</td>
   <td>{{Spec2("SVG1.1")}}</td>
   <td>Initial definition</td>
  </tr>
 </tbody>
</table>
